"use strict";

require("core-js/modules/es.promise");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

const _require = require('cli-spinner'),
      Spinner = _require.Spinner;

const inquirer = require('inquirer');

const log = require('../lib/log');

Spinner.setDefaultSpinnerString(Spinner.spinners[7]);

module.exports.prompt =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(function* (question) {
    if (!global.isInteractive) {
      throw new Error('Prompts are not allowed in non-interactive mode');
    }

    return inquirer.prompt(question);
  });

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();

module.exports.spin =
/*#__PURE__*/
function () {
  var _ref2 = _asyncToGenerator(function* (promise, str) {
    let spinner;

    if (!global.isInteractive) {
      return promise;
    }

    if (global.verboseLevel > 1) {
      log.debug(str);
      return promise;
    }

    try {
      spinner = new Spinner(str);
      spinner.start();
      return promise;
    } finally {
      spinner.stop(true);
    }
  });

  return function (_x2, _x3) {
    return _ref2.apply(this, arguments);
  };
}();