"use strict";

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.promise");

require("core-js/modules/es.string.split");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

const chalk = require('chalk');

const log = require('../lib/log');

const _require = require('../app/ui'),
      spin = _require.spin;

const _require2 = require('./apiclient'),
      buildAPIClient = _require2.buildAPIClient;

const _require3 = require('../cmd'),
      LibraryAddCommand = _require3.LibraryAddCommand,
      LibraryAddCommandSite = _require3.LibraryAddCommandSite;

class CLILibraryAddCommandSite extends LibraryAddCommandSite {
  constructor(argv, apiClient) {
    super();
    this._apiClient = apiClient;

    var _argv$params$name$spl = argv.params.name.split('@');

    var _argv$params$name$spl2 = _slicedToArray(_argv$params$name$spl, 2);

    this.name = _argv$params$name$spl2[0];
    var _argv$params$name$spl3 = _argv$params$name$spl2[1];
    this.version = _argv$params$name$spl3 === void 0 ? 'latest' : _argv$params$name$spl3;
    this.dir = argv.params.dir || process.cwd();
  }

  apiClient() {
    return this._apiClient;
  }

  libraryIdent() {
    // todo - shouldn't this be a promise?
    return {
      name: this.name,
      version: this.version
    };
  }

  projectDir() {
    return this.dir;
  }

  fetchingLibrary(promise, name) {
    return spin(promise, `Adding library ${chalk.blue(name)}`);
  }

  addedLibrary(name, version) {
    return _asyncToGenerator(function* () {
      log.success(`Library ${chalk.blue(name)} ${version} has been added to the project.`);
      log.success(`To get started using this library, run ${chalk.bold('particle library view ' + name)} to view the library documentation and sources.`);
    })();
  }

}

module.exports.command = (apiJS, argv) => {
  const site = new CLILibraryAddCommandSite(argv, buildAPIClient(apiJS));
  const cmd = new LibraryAddCommand();
  return site.run(cmd);
};