"use strict";

const chalk = require('chalk');

const _require = require('../app/ui'),
      spin = _require.spin;

const log = require('../lib/log');

const _require2 = require('./apiclient'),
      buildAPIClient = _require2.buildAPIClient;

const _require3 = require('../cmd'),
      LibraryDeleteCommandSite = _require3.LibraryDeleteCommandSite,
      LibraryDeleteCommand = _require3.LibraryDeleteCommand;

class CLILibraryDeleteCommandSite extends LibraryDeleteCommandSite {
  constructor(argv, apiClient) {
    super();
    this._apiClient = apiClient;
    this.argv = argv;
  }

  libraryIdent() {
    return this.argv.params.name;
  }

  apiClient() {
    return this._apiClient;
  }

  notifyStart(promise, lib) {
    return spin(promise, `Deleting library ${chalk.green(lib)}...`);
  }

  notifyComplete(promise, library, error) {
    if (error) {// this leads to the message being printed twice
      //		log.error(error);
    } else {
      log.success(`Library ${chalk.green(library)} deleted.`);
    }
  }

}

module.exports.CLILibraryDeleteCommandSite = CLILibraryDeleteCommandSite;

module.exports.command = (apiJS, argv) => {
  const site = new CLILibraryDeleteCommandSite(argv, buildAPIClient(apiJS));
  const cmd = new LibraryDeleteCommand();
  return site.run(cmd);
};